using System;
using System.Drawing;
using GrapeCity.SpreadBuilder;
using GrapeCity.SpreadBuilder.Style;
using System.Windows.Forms;
using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.Controls;
using GrapeCity.ActiveReports.SectionReportModel;
using GrapeCity.ActiveReports.Document.Section;
using TextBox = GrapeCity.ActiveReports.SectionReportModel.TextBox;

namespace Spreadbuilder_ChangeColumns
{
    /// <summary>
    /// Summary description for NewActiveReport1.
    /// </summary>
    public partial class NewActiveReport1 : GrapeCity.ActiveReports.SectionReport
    {
        
        System.Windows.Forms.Label lbl = new System.Windows.Forms.Label();
        public GrapeCity.SpreadBuilder.Workbook SpreadBuilderExcelWorkBook { get; set; }
        private Graphics g;
        public NewActiveReport1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            SpreadBuilderExcelWorkBook = new Workbook();
            g = lbl.CreateGraphics();
            g.PageUnit = GraphicsUnit.Pixel;
        }

        private int _rowindex = 0;
        private int _colindex = 0;
        private int _sheetindex = -1;

        private void detail_Format(object sender, EventArgs e)
        {
            foreach (ARControl ctrl in detail.Controls)
            {
                if (ctrl is TextBox)
                {
                    int oldwidth = SpreadBuilderExcelWorkBook.Sheets[_sheetindex].Columns((short)_colindex).Width;
                    TextBox txt = (TextBox)ctrl;
                    //Multiply by 14.40 to set the width of the column as per text width
                    int newwidth = (int)(g.MeasureString(txt.Text, txt.Font).Width * (14.40));
                    oldwidth = (oldwidth > newwidth) ? oldwidth : newwidth;
                    SpreadBuilderExcelWorkBook.Sheets[_sheetindex].Columns((short)_colindex).Width = oldwidth;
                    SpreadBuilderExcelWorkBook.Sheets[_sheetindex].Cell(_rowindex, _colindex).SetValue(txt.Text);
                    _colindex++;
                }
            }
            _rowindex++;
            _colindex = 0;
        }



        //Using the PageStart event to export each page in separate sheet
        //You may use ReportStart event with some modifications, if you want the data in a single sheet
        private void NewActiveReport1_PageStart(object sender, EventArgs e)
        {
            SpreadBuilderExcelWorkBook.Sheets.AddNew();
            _sheetindex++;
            _rowindex = 0;
            foreach (ARControl ctrl in detail.Controls)
            {
                if (ctrl is TextBox)
                {
                    int oldwidth = SpreadBuilderExcelWorkBook.Sheets[0].Columns((short)_colindex).Width;
                    TextBox txt = (TextBox)ctrl;
                    SpreadBuilderExcelWorkBook.Sheets[_sheetindex].Cell(_rowindex, _colindex).FontBold = true;
                    SpreadBuilderExcelWorkBook.Sheets[_sheetindex].Cell(_rowindex, _colindex).FontSize = 12;
                    Font font = new Font(SpreadBuilderExcelWorkBook.Sheets[_sheetindex].Cell(_rowindex, _colindex).FontName, 12, FontStyle.Bold);
                    float t = g.MeasureString(txt.DataField, font).Width;
                    int newwidth = (int)(t * (14.40));
                    oldwidth = (oldwidth > newwidth) ? oldwidth : newwidth;
                    SpreadBuilderExcelWorkBook.Sheets[_sheetindex].Columns((short)_colindex).Width = oldwidth;
                    SpreadBuilderExcelWorkBook.Sheets[_sheetindex].Cell(_rowindex, _colindex).SetValue(txt.DataField);
                    _colindex++;
                }
            }
            _rowindex++;
            _colindex = 0;
        }

      
    }
}
